/*
 2014/03/05 - 11:29:48
 */
var GM = GM || {};
GM.extendedFunctions = {
currentlyRunningOnlineGames: [],
playGame: function(wrappingID, commandSource) {
	if (!commandSource) {
		commandSource = "NoSourceGiven";
	}
	if (wrappingID.toLowerCase().indexOf("t5") > -1) {
		var gameURL = GM.urls.get_url('onlineGameBase') + wrappingID
		if (GM.FTPPage && GM.FTPPage.FTPGames[wrappingID]) {
			gameURL += GM.FTPPage.tracking;
			var defaultWidth = GM.FTPPage.FTPGames[wrappingID].width;
			var defaultHeight = GM.FTPPage.FTPGames[wrappingID].height;
		} else if (GM.pseudoGames[wrappingID]) {
			if (GM.pseudoGames[wrappingID].tracking) {
				gameURL += GM.pseudoGames[wrappingID].tracking
			}
			var defaultWidth = GM.pseudoGames[wrappingID].launchWidth;
			var defaultHeight = GM.pseudoGames[wrappingID].launchHeight;
		} else {
			alert('YOU LAUNCHED THIS ONLINE GAME POORLY');
			return;
		}
		if (window.screen.availHeight <= 768) {
			defaultHeight = Math.floor(window.screen.availHeight * .95);
		}
		var nameOfApp = "BFGameLauncher";
		if (GM.data.userData.platform == 'mac') {
			nameOfApp = "Big Fish Game Launcher";
		}
		GM.console.log("OnlineGame URL launched: " + gameURL);
	} else if (wrappingID.toLowerCase().indexOf("t1") > -1 || wrappingID.toLowerCase().indexOf("t2") > -1) {
		GM.console.log("Starting DL Game play");
		GM.controller.event_to_native('playGame', {
									  wrappingID: wrappingID
									  });
		if (GM.data.installedGames[wrappingID] && !GM.data.installedGames[wrappingID].activated) {
			GM.prices.check_for_updates(GM.data.installedGames[wrappingID].siteID, true);
		}
	} else {
		GM.console.log("UNRECOGNIZED GAME TYPE");
	}
	GM.tracking.sendGamePlayEvent(wrappingID, commandSource);
},
onlineGameHeartBeat: function(data) {
	$('#content').trigger(data.name + "Update", 1);
},
downloadGame: function(data) {
	GM.controller.event_to_native('downloadGame', {
								  wrappingID: data
								  });
},
gameCloseMessage: function(data) {
	$('#content').trigger(data.name + "Update", 0);
},
showOverlay: function(overlayID) {
	GM.overlay.open(overlayID);
},
showGame: function(url) {
	var game_iframe_wrapper = $('<div>').attr("id", "spinning_loader_store").css({
																				 "background-position": "center",
																				 "height": "690px",
																				 "width": "980px",
																				 "margin": "5px",
																				 "border": "0"
																				 });
	var game_iframe = $("<iframe>").attr("id", "game_frame").attr("name", "game_frame").attr("src", url).css({
																											 "height": "100%",
																											 "width": "100%",
																											 "border": "0"
																											 });
	var html_content = $('<div>').append(game_iframe_wrapper.append(game_iframe).clone()).html();
	GM.overlay.open('store', {
					html: html_content
					});
},

LaunchOnlineGame: function(params) {
	var wrappingID = params['wrappingID'];
	if (!wrappingID) {
		return;
	}
},

markGameInstallTileWithAlert: function(multipleParams) {
	var wrappingID, header, message, show_popup;
	multipleParams = multipleParams.split(",");
	if (multipleParams[0]) {
		wrappingID = multipleParams[0];
	}
	if (multipleParams[1]) {
		header = multipleParams[1];
	}
	if (multipleParams[2]) {
		message = multipleParams[2];
	}
	if (multipleParams[3]) {
		show_popup = multipleParams[3];
	}
	if (GM.data.installedGames[wrappingID] && GM.data.installedGames[wrappingID].gameState.state == 4) {
		if (!message) {
			message = "This game requires the install of additional components that you must accept to complete the game installation.";
		}
		if (!header) {
			header = "This game install requires your attention.";
		}
		$('#' + wrappingID + ' > .gm_row_buttons > .gm_action > span').removeClass("icon_sm").removeClass("icon_download").addClass("icon_lg").addClass("icon_alert");
		$('#' + wrappingID + ' > .gm_row_buttons > .gm_action > span').css("position", "absolute").css("top", "10px");
		$('#' + wrappingID + ' > .gm_row_buttons > .gm_action > span').attr("simpletip", message).show();
		if (show_popup) {
			GM.overlay.open("general", {
							err_prompt: "",
							h2: header,
							msg: message
							});
		}
	}
},
showGenericOverlay: function(multipleParams) {
	var header, message, error_prompt;
	multipleParams = multipleParams.split(",");
	if (multipleParams[0]) {
		header = multipleParams[0];
	}
	if (multipleParams[1]) {
		message = multipleParams[1];
	}
	if (multipleParams[2]) {
		error_prompt = multipleParams[2];
	}
	GM.overlay.open("general", {
					err_prompt: error_prompt,
					h2: header,
					msg: message
					});
}
};
$('.sort_games, .instant-games, .sort_f2p, .sort_search').live('click', function(e) {
															   $('#content_outer').css('margin-top', '0px');
															   $('#content_outer').css('height', '100%');
															   $('#content').css("overflow-x", "hidden");
															   });

function showGenericPage(pageClass, javascriptSrc) {
	if (!GM.util.checkIfUserOnline(true)) {
		return;
	}
	$('.sort_active').removeClass('sort_active');
	$('.' + pageClass).addClass('sort_active');
	GM.data.userData.sort.page = pageClass;
	GM.content_header._key_map[pageClass] = " ";
	GM.content_header.draw_header();
	var timestamp = new Date().getUTCMilliseconds();
	var html = "<div id='customPageDiv' style='width:100%; height:100%'><script src='" + javascriptSrc + "?_=" + timestamp + "'></script><div  id='spinning_loader_purchase' class='gm_row' style='border:none; height:450px;' ><span style='display: block;margin:300px auto;' class='icon_spinning'/></div></div>";
	$('#content').html($.tmpl(html, {}));
	GM.gybb.render();
}
$('#f2p_page').live('click', function(e) {
					e.preventDefault();
					showGenericPage("sort_f2p", GM.config.genericPageToScriptMapping["sort_f2p"]);
					});
$('#sort_search').live('click', function(e) {
					   e.preventDefault();
					   showGenericPage("sort_search", GM.config.genericPageToScriptMapping["sort_search"]);
					   });
var GM = GM || {};
GM.pseudoGameUtils = {
metaData: {
installedGames: {},
uninstalledGames: {}
},
removeGame: function(wrappingID) {
	if (GM.pseudoGameUtils.metaData.installedGames[wrappingID]) {
		delete GM.pseudoGameUtils.metaData.installedGames[wrappingID];
	}
	if (!GM.pseudoGameUtils.metaData.uninstalledGames[wrappingID]) {
		GM.pseudoGameUtils.metaData.uninstalledGames[wrappingID] = GM.ads.get_time();
	}
	GM.game_rows.remove_game(wrappingID);
	GM.pseudoGameUtils.storeMetadata();
},
retrieveMetadata: function() {
	GM.deferredObjects.databaseQueryResult = $.Deferred();
	GM.deferredObjects.databaseQueryResult.done(function(result) {
												if (result) {
												var fetchedValue = {
												installedGames: {},
												uninstalledGames: {}
												};
												if ((typeof result === 'string') && (result != "")) {
												fetchedValue = JSON.parse(result).params.value;
												if (fetchedValue != "") {
												fetchedValue = JSON.parse(fetchedValue);
												if (fetchedValue && !fetchedValue.installedGames) {
												fetchedValue.installedGames = {};
												}
												if (fetchedValue && !fetchedValue.uninstalledGames) {
												fetchedValue.uninstalledGames = {};
												}
												} else {
												fetchedValue = {
												installedGames: {},
												uninstalledGames: {}
												};
												}
												}
												if (fetchedValue && fetchedValue.installedGames && fetchedValue.uninstalledGames) {
												GM.pseudoGameUtils.metaData = fetchedValue;
												GM.pseudoGameUtils.parseGameList();
												}
												}
												});
	GM.util.getDatabaseValue("persistent_db", "", "pseudoGameMetadata");
},
parseGameList: function() {
	$.each(GM.pseudoGames, function(i, obj) {
		   if ((GM.pseudoGameUtils.metaData.installedGames[obj.wrappingID]) && (obj.gameType == GM.data.gameType) && (obj.siteID == GM.data.userData.siteID)) {
		   obj.playCount = GM.pseudoGameUtils.metaData.installedGames[obj.wrappingID].playCount;
		   obj.installTime = GM.pseudoGameUtils.metaData.installedGames[obj.wrappingID].installTime;
		   obj.lastActionTime = GM.pseudoGameUtils.metaData.installedGames[obj.wrappingID].lastActionTime;
		   GM.game_rows.update_data_by_wrapID(obj.wrappingID, obj);
		   GM.game_rows.convert(obj.wrappingID);
		   } else if ((!GM.pseudoGameUtils.metaData.uninstalledGames[obj.wrappingID]) && (obj.gameType == GM.data.gameType) && (obj.siteID == GM.data.userData.siteID)) {
		   obj.installTime = GM.ads.get_time();
		   GM.game_rows.update_data_by_wrapID(obj.wrappingID, obj);
		   GM.pseudoGameUtils.metaData.installedGames[obj.wrappingID] = {
		   playCount: 0,
		   installTime: obj.installTime
		   };
		   GM.pseudoGameUtils.storeMetadata();
		   GM.game_rows.convert(obj.wrappingID);
		   }
		   });
	GM.game_rows.sorted[GM.data.userData.sort.sort] = [];
	if (GM.data.userData.sort.page != 'f2p_casino') {
		setTimeout("GM.render.draw_games(GM.data.userData.sort.sort);", 1);
	}
},
setGameInstallTime: function(wrappingID) {
	GM.pseudoGameUtils.metaData.installedGames[wrappingID].installTime = GM.ads.get_time();
	GM.pseudoGameUtils.storeMetadata();
},
updatePlayCount: function(wrappingID) {
	if (GM.pseudoGameUtils.metaData.installedGames[wrappingID]) {
		GM.pseudoGameUtils.metaData.installedGames[wrappingID].lastActionTime = GM.ads.get_time();
		GM.data.installedGames[wrappingID].lastActionTime = GM.pseudoGameUtils.metaData.installedGames[wrappingID].lastActionTime;
		GM.game_rows.sorted.sort_played = [];
		GM.pseudoGameUtils.metaData.installedGames[wrappingID].playCount = GM.pseudoGameUtils.metaData.installedGames[wrappingID].playCount + 1;
		GM.pseudoGameUtils.storeMetadata();
	}
},
storeMetadata: function() {
	var data = JSON.stringify(GM.pseudoGameUtils.metaData).replace(/"/gi, "\\\"");
	GM.util.setDatabaseValue("persistent_db", "", "pseudoGameMetadata", data);
},
moveGameToInstallList: function(wrappingID) {
	if (GM.pseudoGameUtils.metaData.uninstalledGames[wrappingID]) {
		delete GM.pseudoGameUtils.metaData.uninstalledGames[wrappingID];
		GM.pseudoGameUtils.parseGameList();
		GM.pseudoGameUtils.storeMetadata();
	}
},
isGameInInstallList: function(wrappingID) {
	if (GM.pseudoGameUtils.metaData.installedGames[wrappingID]) {
		return true;
	} else {
		return false;
	}
},
isGameInUninstallList: function(wrappingID) {
	if (GM.pseudoGameUtils.metaData.uninstalledGames[wrappingID]) {
		return true;
	} else {
		return false;
	}
}
};
